package com.bonus.zlpt.common.core.utils;

import com.bonus.zlpt.common.core.web.page.PageDomain;
import com.bonus.zlpt.common.core.web.page.TableSupport;
import com.bonus.zlpt.common.core.utils.sql.SqlUtil;
import com.github.pagehelper.PageHelper;

import java.util.Objects;

/**
 * 分页工具类
 * 
 * @author ruoyi
 */
public class PageUtils extends PageHelper
{
    /**
     * 设置请求分页数据
     */
    public static void startPage()
    {
        PageDomain pageDomain = TableSupport.buildPageRequest();
        Integer pageNum = pageDomain.getPageNum();
        Integer pageSize = pageDomain.getPageSize();
        String orderBy = SqlUtil.escapeOrderBySql(pageDomain.getOrderBy());
        Boolean reasonable = pageDomain.getReasonable();
        PageHelper.startPage(pageNum, pageSize, orderBy).setReasonable(reasonable);
    }

    /**
     * 设置请求分页数据
     */
    public static void startPage(Integer pageNum, Integer pageSize)
    {
        PageDomain pageDomain = TableSupport.buildPageRequest();
        if (Objects.isNull(pageNum)) {
            pageNum = pageDomain.getPageNum();
        }
        if (Objects.isNull(pageSize)) {
            pageSize = pageDomain.getPageSize();
        }
        String orderBy = SqlUtil.escapeOrderBySql(pageDomain.getOrderBy());
        Boolean reasonable = pageDomain.getReasonable();
        PageHelper.startPage(pageNum, pageSize, orderBy).setReasonable(reasonable);
    }

    /**
     * 清理分页的线程变量
     */
    public static void clearPage()
    {
        PageHelper.clearPage();
    }
}
